#ifndef GRAPHE_H
#define GRAPHE_H

#include <qlist.h>
#include <qdict.h>

#include "route.h"
#include "ville.h"
#include "ens.h"
#include "base.h"

//***********************************************************************************************************
// CETTE CLASSE N'A PAS A ETRE UTILISEE
// PAR D'AUTRES PERSONNES QUE CELLES DU GROUPE CONNEXION

class ensemble
{
 private:
  QDict<const Ville> contenu;

 public:
  ensemble();
  virtual ~ensemble();

  // Les mthodes dont on aura besoin:

  // vider l'ensemble:
  virtual void vide(); // O(n), mais appele 1 fois seulement.

  // test d'appartenance:
  virtual bool contient(const Ville) const; // rapide grace  la fonction de hachage.

  // insertion d'un nouvel lment:
  virtual void ajoute(const Ville); // Pas de problme de double-insertion (fonction de hachage)

  // taille de l'ensemble:
  virtual unsigned int cardinal();
};

//***********************************************************************************************************

class Graphe: virtual public Base 
{
 private:
  ensemble atteintes;
  const Ville * arrivee;      // pour les mthodes reliees    et butAtteint.
  QList<Ville> * listeVilles; // pour les mthodes composante et descente  .

  virtual bool butAtteint(const Ville * const);
  virtual void descente  (const Ville * const);

 public:


  Graphe() {};
  virtual ~Graphe() {};
  
  // Mthode testant si les 2 villes passes en paramtre sont dans la meme composante connexe:
  virtual bool reliees(const Ville * const, const Ville * const);
  
  // Mthode renvoyant la liste de toutes les villes se trouvant dans la meme composante connexe que v:
  virtual QList<Ville> & composante(const Ville * const v);
  
  // Mthode renvoyant la liste des composantes connexes du graphe pass en paramtre:
  virtual QList <QList<Ville> > & listeComposantes();

  //*************************************************************************************************
  // liste des villes voisines d'une ville donne:
  virtual QList<Ville> & VillesVoisines(Ville * const);
};

//***********************************************************************************************************

#endif
