#include <iostream.h>
#include "base.h"
#include "rechdial.h"
#include "fenresultat.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <qlist.h> 
#include <qapplication.h> 
#include "qfiledialog.h" 
#include <stdlib.h>

void Base::recherche()
{   FenetreRecherche fen;
    if(fen.exec())
    {
      QList<Ville> l=recherchev(fen.valtyp,fen.valregion,fen.valaltmax,fen.valaltmin,fen.valhabmax,fen.valhabmin,fen.valnom,fen.valy,fen.valx);
      
      ResDiag res(l);

      res.show();
    }
}
   
QList<Ville> Base::rech_x(uniteCoor x)
{
   QList<Ville> l;

   if(x==0)
      return l;
   else
   {
      Ville *p=v.tete();
      verifier=TRUE;
        
      while(p!=NULL)
      {
         if(p->retx()==x)
            l.insert(0,p);

         p=v.Suivant(p);
      }

      return l;
   }
}


QList<Ville> Base::rech_y(uniteCoor y,QList<Ville> l)
{
   if(y!=0)
   {
      if(l.isEmpty() && !verifier)
      {
         Ville *p=v.tete();
         verifier=TRUE;

         while(p!=NULL)
         {
            if(p->rety()==y)
               l.insert(0,p);

            p=v.Suivant(p);
         }
      }
      else
      {
         l.getFirst();

         while(l.current()!=NULL)
         {
            if(l.current()->rety()!=y)
               l.remove();

            l.next();
         }
      }
   }

   return l;
}


QList<Ville> Base::rech_nom(QString nom,QList<Ville> l)
{
   if(!nom.isEmpty())
   {
      if(l.isEmpty() && !verifier)
      {
         Ville *p=v.tete();
         verifier=TRUE;

         while(p!=NULL)
         {
            if(p->retNom().lower().find((const char*)nom.lower())!=-1)
               l.insert(0,p);

            p=v.Suivant(p);
         }
      }
      else
      {
         l.getFirst();

         while(l.current()!=NULL)
         {
            if(l.current()->retNom().lower().find((const char*)nom.lower())==-1)
               l.remove();

            l.next();
         }
      }
   }

   return l;
}


QList<Ville> Base::rech_altmin(int altmin, QList<Ville> l)
{
   if(altmin!=-1)
   {
      if(l.isEmpty() && !verifier)
      {
         Ville *p=v.tete();
         verifier=TRUE;

         while(p!=NULL)
         {
            if(p->retAlt()>=altmin)
               l.insert(0,p);

            p=v.Suivant(p);
         }
      }
      else
      {
         l.getFirst();

         while(l.current()!=NULL)
         {
            if(l.current()->retAlt()<altmin)
               l.remove();

            l.next();
         }
      }
   }

   return l;
}


QList<Ville> Base::rech_altmax(int altmax, QList<Ville> l)
{
   if(altmax!=-1)
   {
      if(l.isEmpty() && !verifier)
      {
         Ville *p=v.tete();
         verifier=TRUE;

         while(p!=NULL)
         {
            if(p->retAlt()<=altmax)
               l.insert(0,p);

            p=v.Suivant(p);
         }
      }
      else
      {
         l.getFirst();

         while(l.current()!=NULL)
         {
            if(l.current()->retAlt()>=altmax)
               l.remove();

            l.next();
         }
      }
   }

   return l;
}


QList<Ville> Base::rech_habmin(long habmin, QList<Ville> l)
{
   if(habmin!=-1)
   {
      if(l.isEmpty() && !verifier)
      {
         Ville *p=v.tete();
         verifier=TRUE;

         while(p!=NULL)
         {
            if(p->retPop()>= habmin)
               l.insert(0,p);

            p=v.Suivant(p);
         }
      }
      else
      {
         l.getFirst();

         while(l.current()!=NULL)
         {
            if(l.current()->retPop() <= habmin)
               l.remove();

            l.next();
         }
      }
   }

   return l;
}


QList<Ville> Base::rech_habmax(long habmax, QList<Ville> l)
{
   if(habmax!=-1)
   {
      if(l.isEmpty() && !verifier)
      {
         Ville *p=v.tete();
         verifier=TRUE;

         while(p!=NULL)
         {
            if(p->retPop()<=habmax)
               l.insert(0,p);

            p=v.Suivant(p);
         }
      }
      else
      {
         l.getFirst();

         while(l.current()!=NULL)
         {
            if(l.current()->retPop()>= habmax)
               l.remove();

            l.next();
         }
      }
   }

   return l;
}


QList<Ville> Base::rech_region(QString region,QList<Ville> l)
{
   if(!region.isEmpty())
   {
      if(l.isEmpty() && !verifier)
      {
         Ville *p=v.tete();
         verifier=TRUE;

         while(p!=NULL)
         {
            if(p->retReg().lower().find((const char*)region.lower())!=-1)
               l.insert(0,p);

            p=v.Suivant(p);
         }
      }
      else
      {
         l.getFirst();

         while(l.current()!=NULL)
         {
            if(l.current()->retReg().lower().find((const char*)region.lower())==-1)
               l.remove();

            l.next();
         }
      }
   }

   return l;
}


QList<Ville> Base::rech_vil_type(int typ, QList<Ville> l)
{
   char c;

   if(typ!=0)
   {
      if(l.isEmpty() && !verifier)
      {
         Ville * p=v.tete();
         verifier = TRUE;

         while(p!=NULL)
         {
            c=p->retTyp()[0];

            if (appartienttyp(typ,c))
               l.insert (0,p);

            p=v.Suivant(p);
         }
      }
      else
      {
         l.getFirst();

         while (l.current()!=NULL)
         {
            c=l.current()->retTyp()[0];

            if (appartienttyp(typ,c))
               l.remove();

            l.next();
         }
      }
   }

   return l;
}


bool Base::appartienttyp(int t, char typ)
{
    if(t==1 && typ=='c')
       return TRUE;
    else
    {
       if(t==2 && typ=='r')
          return TRUE;
       else
       {
          if(t==3 && typ=='p')
             return TRUE;
          else
          {
             if(t==4 && typ=='s')
                return TRUE;
             else
             {
                if(t==5 && typ=='b')
                   return TRUE;
                else
                   return FALSE;
             }
          }
       }
    }
}


QList<Ville> Base::recherchev(int typ,QString region,int altmax,int altmin,long habmax,long habmin,QString nom,uniteCoor y,uniteCoor x)
{
    verifier=FALSE;
    
    return rech_vil_type(typ,rech_region(region,rech_altmax(altmax,rech_altmin(altmin,rech_habmax(habmax,rech_habmin(habmin,rech_nom(nom,rech_y(y,rech_x(x)))))))));
}

