#include "carte.h"

Carte::Carte( QWidget * parent = 0, const char * name = 0, WFlags f = 0 ):QMainWindow(parent,name)
{
  pImage = new Image(this );
  pImage->charger("carteff71.gif");
  pImage->show();
  resize(pImage->width(),pImage->height());
  connect(pImage,SIGNAL(imageResized()),this,SLOT(myResize()));
  setFocusPolicy(StrongFocus);
}

Carte::Carte( QPixmap* pPixmap, QWidget * parent = 0, const char * name = 0, WFlags f = 0 ):QMainWindow(parent,name)
{
  pImage = new Image( *pPixmap, this );
  pImage->show();
  resize(pImage->width(),pImage->height());
  connect(pImage,SIGNAL(imageResized()),this,SLOT(myResize()));
  setFocusPolicy(StrongFocus);
}


Carte::~Carte()
{
}

void Carte::modDimensions(uniteCoor x,uniteCoor y) {
  pImage->modDimensions(x,y);
}

void Carte::resizeEvent(QResizeEvent *e)
{
  pImage->resize((e->size()).width(),(e->size()).height());
}

void Carte::myResize()
{
  this->resize(pImage->width(),pImage->height());
}

void Carte::charger(const QPixmap &pmap)
{
  pImage->charger(pmap);
}

void Carte::charger(const QString &nomFichier)
{
  pImage->charger(nomFichier);
}

void Carte::charger(const char *nomFichier)
{
  pImage->charger(nomFichier);
}

void Carte::recharger()
{
  pImage->recharger();
}

void Carte::zoom1_4()
{
  pImage->zoom1_4();
}

void Carte::zoom1_3()
{
  pImage->zoom1_3();
}

void Carte::zoom1_2()
{
  pImage->zoom1_2();
}

void Carte::zoom1_1()
{
  pImage->zoom1_1();
}

void Carte::zoom2_1()
{
  pImage->zoom2_1();
}

void Carte::zoom3_1()
{
  pImage->zoom3_1();
}

void Carte::zoom4_1()
{
  pImage->zoom4_1();
}

void Carte::changeOutils(int i)
{
  pImage->changeOutils(i);
}

void Carte::outilsSelection()
{
  pImage->outilsSelection();
}

void Carte::outilsZoom()
{
  pImage->outilsZoom();
}

void Carte::keyPressEvent(QKeyEvent *e)
{
  //if (!valide())
  //return;

  QPoint	pos;
  QSize	s	= pImage->maximumSize();
  pos=pImage->position();

  switch(e->key())
    {
    case Key_Home:
      pImage->scrollAbsolu(0, pos.y());
      break;
      
    case Key_End:
      pImage->scrollAbsolu(s.width(), pos.y());
      break;
      
    case Key_PageUp:
      pImage->scrollAbsolu(pos.x(), 0);
      break;

    case Key_PageDown:
      pImage->scrollAbsolu(pos.x(), s.height());
      break;

    case Key_Up:
      pImage->scroll(0, -10);
      break;
      
    case Key_Down:
      pImage->scroll(0, 10);
      break;
      
    case Key_Left:
      pImage->scroll(-10, 0);
      break;
      
    case Key_Right:
      pImage->scroll(10, 0);
      break;
    
    case Key_Delete:
     pImage->supprimerSelectionCourante();
     break;
}
}


// rajoutees par coordination
void Carte::supprimerSelectionCourante()
{
  pImage->supprimerSelectionCourante();
}


void Carte::exportBase()
{
  pImage->exportBase();
}

void Carte::importBase()
{
  pImage->importBase();
}

void Carte::proprietes()
{

}


void Carte::focusOutEvent( QFocusEvent* e )
  //  : QWidget::focusOutEvent( e )
{
  emit focusPerdu( this );
}


void Carte::imprimer()
{
  pImage->imprimer();
}

void Carte::defaire()
{
  pImage->defaire();
}

Graphe* Carte::getGraphe()
{
  return pImage->getGraphe();
}

void Carte::calculVoisins()
{
  pImage->calculVoisins();
}

void Carte::connexiteGraphe()
{
  pImage->connexiteGraphe();
}
