#ifndef CARTE_H
#define CARTE_H
#include <qscrollview.h>
#include <qmainwindow.h>
#include <qevent.h>
#include "Image.h"

class Carte:public QMainWindow
{
Q_OBJECT
  public :
    Image* pImage;

  public :
  Carte( QWidget * parent = 0, const char * name = 0, WFlags f = 0 );
  Carte( QPixmap*,  QWidget * parent = 0, const char * name = 0, WFlags f = 0 );
  ~Carte();
  virtual void  modDimensions(uniteCoor,uniteCoor);

  // Rajoutees par coordination
  virtual void supprimerSelectionCourante();
  virtual void proprietes();
  virtual Graphe* getGraphe();

  protected:
  void resizeEvent(QResizeEvent *e);
  void keyPressEvent(QKeyEvent *e);
  void focusOutEvent( QFocusEvent* );
  
  signals:
  void focusPerdu( Carte* );

  public slots:

  void calculVoisins();
  void connexiteGraphe();
  void defaire();
  void imprimer();
  void exportBase();
  void importBase();
  virtual void charger(const QPixmap &pmap);
  virtual void charger(const QString &nomFichier);
  virtual void charger(const char *nomFichier); 
  virtual void recharger();
  virtual void zoom1_4();
  virtual void zoom1_3();
  virtual void zoom1_2();
  virtual void zoom1_1();
  virtual void zoom2_1();
  virtual void zoom3_1();
  virtual void zoom4_1();
  void myResize();
  void changeOutils(int);
  void outilsSelection();
  void outilsZoom();
};

#endif
