#include <qmessagebox.h>

//////// debug
#include <iostream.h>
/////////////////

#include <stdio.h>

#include "dialogs.h"

//////////////////////
// class DEditRoute //
//////////////////////

DEditRoute::DEditRoute(Route *ro,QWidget *parent=0, 
			     const char *name=0) 
  : QDialog (parent,name,TRUE) {
  setCaption("Route");
  r=ro;
  
  char tmp[100];
  
  setFixedSize(340,170);
  
  g_route=new QGroupBox("Attributs de la route:",this);
  g_route->setGeometry(10,10,320,110);

  l_nom=new QLabel(g_route);
  l_nom->setText("Nom:");
  l_nom->setGeometry(10,25,100,20);

  ed_nom=new QLineEdit(g_route);
  ed_nom->setText(r->retNom());
  ed_nom->setGeometry(100,25,200,20);

  l_longueur=new QLabel(g_route);
  l_longueur->setText("Longueur:");
  l_longueur->setGeometry(10,50,100,20);

  ed_longueur=new QLineEdit(g_route);
  if ((r->retLongueur())!=0)
    { (sprintf(tmp,"%.2f",r->retLongueur()));}
    else tmp[0]=0;
  ed_longueur->setText(tmp);
  ed_longueur->setGeometry(100,50,200,20);

  l_type=new QLabel(g_route);
  l_type->setText("Type:");
  l_type->setGeometry(10,75,100,20);

  c_type=new QComboBox(g_route);
  c_type->setGeometry(100,75,200,20);

  c_type->insertItem ("autoroute", 0);
  c_type->insertItem ("nationale", 1);
  c_type->insertItem ("departementale", 2);
  c_type->insertItem ("communale", 3);
  c_type->insertItem ("chemin carrossable");

  switch(r->retType()) {
  case 'a':  c_type->setCurrentItem(0);break;
  case 'n':  c_type->setCurrentItem(1);break;
  case 'd':  c_type->setCurrentItem(2);break;
  case 'c':  c_type->setCurrentItem(3);break;
  case 'h':  c_type->setCurrentItem(4);break;
  default : r->modType('n'); c_type->setCurrentItem(1); 
  }

  ok=new QPushButton( "Ok", this );
  ok->setGeometry( 50, 130, 100,30 );

  cancel=new QPushButton( "Annuler", this );
  cancel->setGeometry( 190, 130, 100,30 );

  connect(ok,SIGNAL(clicked()),SLOT(check_data()));
  connect(cancel,SIGNAL(clicked()),SLOT(reject()));
}

DEditRoute::~DEditRoute() {} 

void DEditRoute::check_data() {
  uniteDist n;
  char tmp[100];
  if (sscanf(ed_longueur->text(),"%lf %s",&n,tmp)!=1) 
    QMessageBox::information(this,"Info","Erreur dans les attributs.");
  else {
    r->modNom(ed_nom->text());
    r->modLongueur(n);
    switch(c_type->currentItem()) {
    case 0: r->modType('a'); break;
    case 1: r->modType('n'); break;
    case 2: r->modType('d'); break;
    case 3: r->modType('c'); break;
    case 4: r->modType('h'); break;
    }
    accept();
  }
}
  
  

bool DEditRoute::edition(Route* r) {
  DEditRoute edit(r);
  return edit.exec();
}

//////////////////////
// class DEditVille //
//////////////////////
	      
DEditVille::DEditVille(Ville *vi,QWidget *parent=0, 
			     const char *name=0) 
  : QDialog (parent,name,TRUE) {
  setCaption("Ville");
  v=vi;
  
  char tmp[100];
  
  setFixedSize(340,210);
  
  g_ville=new QGroupBox("Attributs de la ville:",this);
  g_ville->setGeometry(10,10,320,150);

  l_nom=new QLabel(g_ville);
  l_nom->setText("Nom:");
  l_nom->setGeometry(10,20,100,20);

  ed_nom=new QLineEdit(g_ville);
  ed_nom->setText(v->retNom());
  ed_nom->setGeometry(100,20,200,20);

  l_population=new QLabel(g_ville);
  l_population->setText("Population:");
  l_population->setGeometry(10,45,100,20);

  ed_population=new QLineEdit(g_ville);
 if(v->retPop()!=0)  
   sprintf(tmp,"%li",v->retPop());
 else tmp[0]=0 ;
 ed_population->setText(tmp);
  ed_population->setGeometry(100,45,200,20);

  l_altitude=new QLabel(g_ville);
  l_altitude->setText("Altitude:");
  l_altitude->setGeometry(10,70,100,20);

  ed_altitude=new QLineEdit(g_ville);
 if (v->retAlt()!=0) sprintf(tmp,"%i",v->retAlt());
 else tmp[0]=0;
  ed_altitude->setText(tmp);
  ed_altitude->setGeometry(100,70,200,20);

  l_region=new QLabel(g_ville);
  l_region->setText("Region:");
  l_region->setGeometry(10,95,100,20);

  ed_region=new QLineEdit(g_ville);
  ed_region->setText(v->retReg());
  ed_region->setGeometry(100,95,200,20);

  l_type=new QLabel(g_ville);
  l_type->setText("Type:");
  l_type->setGeometry(10,120,100,20);

  c_type=new QComboBox(g_ville);
  c_type->setGeometry(100,120,200,20);

  c_type->insertItem ("Capitale", 0);
  c_type->insertItem ("Capitale de Region", 1);
  c_type->insertItem ("Prefecture", 2);
  c_type->insertItem ("Sous-Prefecture", 3);
  c_type->insertItem ("Bled paum", 4);

 
  switch((v->retTyp())[0]) {
  case 'c':  c_type->setCurrentItem(0);break;
  case 'r':  c_type->setCurrentItem(1);break;
  case 'p':  c_type->setCurrentItem(2);break;
  case 's':  c_type->setCurrentItem(3);break;
  case 'b':  c_type->setCurrentItem(4);break;
  default : v->modTyp('b'); c_type->setCurrentItem(4); 
  }

  ok=new QPushButton( "Ok", this );
  ok->setGeometry( 50, 170, 100,30 );

  cancel=new QPushButton( "Annuler", this );
  cancel->setGeometry( 190, 170, 100,30 );

  connect(ok,SIGNAL(clicked()),SLOT(check_data()));
  connect(cancel,SIGNAL(clicked()),SLOT(reject()));
}

DEditVille::~DEditVille() {} 

void DEditVille::check_data() {
  long pop; 
  int alt;
  char tmp[100];
  if ((sscanf(ed_population->text(),"%li %s",&pop,tmp)!=1)||
      (sscanf(ed_altitude->text(),"%i %s",&alt,tmp)!=1)) 
    QMessageBox::information(this,"Info","Erreur dans les attributs.");
  else {
    v->modNom(ed_nom->text());
    v->modPop(pop);
    v->modAlt(alt);
    v->modReg(ed_region->text());

    switch(c_type->currentItem()) {
    case 0: v->modTyp("c"); break;
    case 1: v->modTyp("r"); break;
    case 2: v->modTyp("p"); break;
    case 3: v->modTyp("s"); break;
    case 4: v->modTyp("b"); break;
    }
    accept();
  }
}
  
  

bool DEditVille::edition(Ville* v) {
  DEditVille edit(v);
  return edit.exec();
}










