#include "geometrie.h"

//  QPoint_<TYPE>
template<class TYPE>
QPoint_<TYPE>::QPoint_() { X=Y=0; }

template<class TYPE>
QPoint_<TYPE>::QPoint_(TYPE i,TYPE j) { X=i; Y=j; }

template<class TYPE>
QPoint_<TYPE>::QPoint_(int i,int j) { X=(TYPE)i; Y=(TYPE)j; }

template<class TYPE>
QPoint_<TYPE>::~QPoint_() { }

template<class TYPE>
TYPE QPoint_<TYPE>::x() const { return X; }

template<class TYPE>
TYPE QPoint_<TYPE>::y() const { return Y; }

template<class TYPE>
void QPoint_<TYPE>::Init(TYPE i,TYPE j) { X=i; Y=j; }

template<class TYPE>
bool QPoint_<TYPE>::Intersection(const QEqua_<TYPE> & E1,const QEqua_<TYPE> & E2)
{
  TYPE d=E1.a()*E2.b()-E2.a()*E1.b();
  if (d==0) return false;
  else
  {
    X=(E1.b()*E2.c()-E2.b()*E1.c())/d;
    Y=(E1.a()*E2.c()-E2.a()*E1.c())/(-d);
    return true;
  }
}

template<class TYPE>
bool QPoint_<TYPE>::DansRectangle(const QRect_<TYPE> & R)
{
  return (R.x1()<=X && X<=R.x2() && R.y1()<=Y && Y<=R.y2());
}

//  QRect_<TYPE>
template<class TYPE>
QRect_<TYPE>::QRect_() { X1=Y1=X2=Y2=0; }

template<class TYPE>
QRect_<TYPE>::QRect_(TYPE i,TYPE j,TYPE k,TYPE l)
{ 
  if (i<k) { X1=i; X2=k; }
  else { X1=k; X2=i; }

  if (j<l) { Y1=j; Y2=l; }
  else { Y1=l; Y2=j; }
}

template<class TYPE>
QRect_<TYPE>::~QRect_() { }

template<class TYPE>
TYPE QRect_<TYPE>::x1() const { return X1; }

template<class TYPE>
TYPE QRect_<TYPE>::y1() const { return Y1; }

template<class TYPE>
TYPE QRect_<TYPE>::x2() const { return X2; }

template<class TYPE>
TYPE QRect_<TYPE>::y2() const { return Y2; }

template<class TYPE>
void QRect_<TYPE>::Init(TYPE i,TYPE j,TYPE k,TYPE l)
{ 
  if (i<k) { X1=i; X2=k; }
  else { X1=k; X2=i; }

  if (j<l) { Y1=j; Y2=l; }
  else { Y1=l; Y2=j; }
}

//  QEqua_<TYPE>
template<class TYPE>
QEqua_<TYPE>::QEqua_() { A=B=C=0; }

template<class TYPE>
QEqua_<TYPE>::QEqua_(TYPE i,TYPE j,TYPE k) { A=i; B=j; C=k; }

template<class TYPE>
QEqua_<TYPE>::~QEqua_() { }

template<class TYPE>
TYPE QEqua_<TYPE>::a() const { return A; }

template<class TYPE>
TYPE QEqua_<TYPE>::b() const { return B; }

template<class TYPE>
TYPE QEqua_<TYPE>::c() const { return C; }

template<class TYPE>
void QEqua_<TYPE>::Init(TYPE i,TYPE j,TYPE k) { A=i; B=j; C=k; }

template<class TYPE>
void QEqua_<TYPE>::Droite(const QPoint_<TYPE> & P1,const QPoint_<TYPE> & P2)
{
  A=P2.y()-P1.y();
  B=P1.x()-P2.x();
  C=-A*P1.x()-B*P1.y();
}

template<class TYPE>
void QEqua_<TYPE>::PerpendiculaireDroite(const QPoint_<TYPE> & P1,const QPoint_<TYPE> & P2,const QPoint_<TYPE> & P)
{
  A=P1.x()-P2.x();
  B=P1.y()-P2.y();
  C=-A*P.x()-B*P.y();
}


