#ifndef GEOMETRIE_H
#define GEOMETRIE_H


template <class TYPE>
class QRect_;

template <class TYPE>
class QEqua_;


template<class TYPE>
class QPoint_
{
  private:
    TYPE X,Y;
  public:
    QPoint_();
    QPoint_(TYPE,TYPE);
    QPoint_(int,int);
    ~QPoint_();
    TYPE x() const;
    TYPE y() const;
    void Init(TYPE,TYPE);
    bool Intersection(const QEqua_<TYPE> &,const QEqua_<TYPE> &);
    bool DansRectangle(const QRect_<TYPE> &);
};

template<class TYPE>
class QRect_
{
  private:
    TYPE X1,Y1,X2,Y2;
  public:
    QRect_();
    QRect_(TYPE,TYPE,TYPE,TYPE);
    ~QRect_();
    TYPE x1() const;
    TYPE y1() const;
    TYPE x2() const;
    TYPE y2() const;
    void Init(TYPE,TYPE,TYPE,TYPE);
};

template<class TYPE>
class QEqua_
{
  private:
    TYPE A,B,C;
  public:
    QEqua_();
    QEqua_(TYPE,TYPE,TYPE);
    ~QEqua_();
    TYPE a() const;
    TYPE b() const;
    TYPE c() const;
    void Droite(const QPoint_<TYPE> &,const QPoint_<TYPE> &);
    void PerpendiculaireDroite(const QPoint_<TYPE> &,const QPoint_<TYPE> &,const QPoint_<TYPE> &);
    void Init(TYPE,TYPE,TYPE);
};

#endif
