#ifndef RouteVille_h
#define RouteVille_h
#include <qstring.h> 
#include <string>
#include <qlist.h>
#include <qpainter.h>

#define  uniteCoor double
#define  uniteDist double

class Base;
class Ville;
class Route;

class RouteVille
{
private:
QString nom;

public:

bool supprime;                  // Mis  vrai ou faux par sauve_defaire() lors de la sauvegarde.

RouteVille ();
virtual ~RouteVille();
virtual QString retNom() const;
virtual void modNom(QString);
virtual bool estVille() const=0;
virtual QString rethash()const=0;
virtual bool sauveRoutVille(int desc)=0;
virtual bool restitRoutVille(int descr,Base*)=0;

virtual long retPop() const ;
virtual int retAlt() const ;
virtual QString retReg() const ;
virtual QString retTyp() const ;
virtual uniteCoor retx() const=0 ;
virtual uniteCoor rety() const=0 ;

virtual QList<Route> retVoisins();

virtual Ville* retextrem1() const ;
virtual Ville* retextrem2() const ;
virtual uniteDist retLongueur() const ;
virtual char retType() const ;

virtual void defaire(Base *);
virtual void refaire(Base *);

virtual void affiche (QPainter*, QColor c = black); 


};

#endif
