#include <iostream.h>
#include "tLidou.h"

//attention a l'ecriture de Place quand c'est un type de retour

//typedef Cellule<TypeValeur>* Place;

// Constructeurs et destructeur//////////////////////////////////
template<class TypeValeur>
ListeDouble<TypeValeur>:: ListeDouble()
{nbElem = 0; tete = NULL; queue = NULL;}

template<class TypeValeur>
ListeDouble<TypeValeur>::ListeDouble(const ListeDouble<TypeValeur>& L)
 {nbElem = 0; tete=queue=NULL;
  Place p = L.premier();
  while (p != PlaceVide)
  { ajoutApres(dernier(), L.valeur(p));  p = L.suivant(p); }
 }

template<class TypeValeur>
ListeDouble<TypeValeur>::~ListeDouble() 
{raz();}

  // Predicat renvoyant vrai ssi la liste est vide,/////////////////
template<class TypeValeur>
bool ListeDouble<TypeValeur>::videP()const
{ return (tete == NULL);}

  // Fonction de remise a zero de la liste////////////////////////
template<class TypeValeur>
void ListeDouble<TypeValeur>::raz()
  {Place q, p = premier();
   while (p != PlaceVide) {q = p;p = suivant(p); delete q;}
   tete = queue = NULL; nbElem = 0;
  }

  // Acces en consultation a la longueur de la liste/////////////
template<class TypeValeur>  
int ListeDouble<TypeValeur>::longueur()const
{ return nbElem;}

// Ajout apres une Place donnee///////////////////////////////////
template<class TypeValeur>
void ListeDouble<TypeValeur>::ajoutApres(Cellule<TypeValeur> * p, TypeValeur v)
{Cellule<TypeValeur> * pCel = new Cellule<TypeValeur>(v);
  if (videP())  {tete = queue = pCel;}
   else
      {pCel->setSuiv(suivant(p));pCel->setPrec(p);
       p->setSuiv(pCel);
       if (p==queue) queue=pCel;
            else  suivant(pCel)->setPrec(pCel);
      }
  nbElem++;
};

  // Ajout avant une Place donnee/////////////////////////////////
template<class TypeValeur>
void ListeDouble<TypeValeur>::ajoutAvant(Place p, TypeValeur v)
{Cellule<TypeValeur> * pCel = new Cellule<TypeValeur>(v);
  if (videP()) {tete = queue = pCel; }
   else
      {pCel->setSuiv(p);pCel->setPrec(precedent(p));
       p->setPrec(pCel);
       if (p==tete) tete=pCel; else  precedent(pCel)->setSuiv(pCel);
      }
  nbElem++;
}

// Enlever la cellule a une Place donnee//////////////////////////
template<class TypeValeur>
void ListeDouble<TypeValeur>::enleve(Place p)
  {if (nbElem==1)  {tete=queue=NULL;}
   else 
      { if (p==tete) tete = suivant(p);
         else precedent(p)->setSuiv(suivant(p));
	if (p==queue) queue = precedent(p);
         else suivant(p)->setPrec(precedent(p));
      }
   nbElem--;
}

// Donner la Place precedant une Place///////////////////////////////
template<class TypeValeur>
ListeDouble<TypeValeur>::Place ListeDouble<TypeValeur>::precedent(Place p)const
 {return p->getPrec();}

// Donner la Place suivant une Place//////////////////////////////////
template<class TypeValeur>
ListeDouble<TypeValeur>::Place ListeDouble<TypeValeur>::suivant(Place p)const
 {return p->getSuiv();}

// Place du premier element///////////////////////////////////////////
template<class TypeValeur>
ListeDouble<TypeValeur>::Place  ListeDouble<TypeValeur>::premier()const
 { return tete;}

// Place du dernier element////////////////////////////////////////////
template<class TypeValeur>
ListeDouble<TypeValeur>::Place ListeDouble<TypeValeur>::dernier() const
 { return queue;}

// Acces a la valeur a une Place donnee///////////////////////////////
template<class TypeValeur>
TypeValeur ListeDouble<TypeValeur>::valeur(Place p)const
 { return p->getVal();}


// Affiche le contenu de la liste////////////////////////////////////
template<class TypeValeur>
void ListeDouble<TypeValeur>::affiche(ostream& os)const
  {os << "\n   (\n  ";   Place p = premier();
   while (p != NULL)
     {os << " " << valeur(p)<<endl<<"  ";p = suivant(p);}
   os << " )"<<endl;
  }



// Fonction de recherche d'un lement
template<class TypeValeur>
ListeDouble<TypeValeur>::Place ListeDouble<TypeValeur>::recherche(TypeValeur TV) const
{Place pr=premier();
while(pr!=NULL)
  {if (*valeur(pr)==*TV) return pr;
  pr=suivant(pr);}
 return pr;}
 

//redefinition de = /////////////////////////////////////////////////
template<class TypeValeur>
ListeDouble<TypeValeur>& ListeDouble<TypeValeur>::operator= 
                                      (const ListeDouble<TypeValeur>& L)
{if(this != &L)//eliminer le cas L=L
  {raz(); 
   Place p = L.premier();
   while (p != PlaceVide)
    { ajoutApres(dernier(), L.valeur(p)); p = L.suivant(p);}
  }
  return *this;
}

//redefinition de <<
template<class TypeValeur>
ostream& operator<< (ostream& os, const ListeDouble<TypeValeur>& L)
{L.affiche(os);return os;}


