//on a rajout une fonction recherche .



#ifndef tLidou_h
#define tLidou_h
#include "tCellule.h"
#include <iostream.h>



template<class TypeValeur>
class ListeDouble{

public:
  // definition du type Place, pointeur sur une cellule
  typedef Cellule<TypeValeur>* Place;
  //initialisation directe: meme valeur pour toutes les classes instanciees
  static const Place PlaceVide=NULL;
 
private:
  int nbElem;
  Place tete, queue;

public:
  ListeDouble();
  ListeDouble(const ListeDouble<TypeValeur>&);
  virtual ~ListeDouble();

  // Predicat renvoyant vrai ssi la liste est vide,
  virtual bool videP()const;

  // Fonction de vidage de la liste
  virtual void raz();

  // Acces en consultation a la longueur de la liste
  virtual int longueur()const;

  // Ajout apres une Place donnee
  virtual void ajoutApres(Place, TypeValeur);

  // Ajout avant une Place donnee
  virtual void ajoutAvant(Place, TypeValeur);

  // Enlever la cellule a une Place donnee
  virtual void enleve(Place);

  // Donner la Place precedant une Place
  virtual Place precedent(Place)const;

  // Donner la Place suivant une Place
  virtual Place suivant(Place)const;

  // Place du premier element
  virtual Place premier()const;

  // Place du dernier element
  virtual Place dernier()const;

  // Acces a la valeur a une Place donnee
  virtual TypeValeur valeur(Place)const;

  // Affiche le contenu de la liste
   virtual void affiche(ostream& os)const;

  //Fonction Rajoute :
  // Fonction de recherche d'un lement.
  virtual Place recherche(TypeValeur) const;

  // surcharge de l'oprateur d'affectation
  virtual ListeDouble& operator= (const ListeDouble<TypeValeur>&);
};

  // surcharge de l'oprateur <<
template<class TypeValeur>
 ostream& operator<< (ostream&, const ListeDouble<TypeValeur>&);

#endif









