
#include <string>
#include <qlist.h>
#include "route.h"
#include "ville.h" 
#include "routeVille.h"
#include "undo.h"
#include "base.h"

Undo_Redo DEFAIRE;


Undo_Redo::Undo_Redo() 
{
  Pile_Undo=new QList<RouteVille >; 
  Pile_Redo=new QList<RouteVille >;
  Pile_Undo->setAutoDelete( TRUE );     // delete items when they are removed
}
Undo_Redo::~Undo_Redo() {}
QList<RouteVille> *Undo_Redo::getP_U() { return  Pile_Undo; }
QList<RouteVille> *Undo_Redo::getP_R() { return  Pile_Redo; }
int Undo_Redo::countP_U(){ return  Pile_Undo->count(); }
int Undo_Redo::countP_R(){ return  Pile_Redo->count(); }
int Undo_Redo::NbreMaxDefRef()const {return nbre_def_ref; }

void Ville::sauve_defaire(int fc)
{
  if (fc==0) 
    {
      (this->supprime)=TRUE;
    }
  if((DEFAIRE.countP_U()) < (DEFAIRE.NbreMaxDefRef()))
    (DEFAIRE.getP_U())->append(this);             // On met la ville (qui se retrouve en tete de Pile).
  else {
    (DEFAIRE.getP_U())->removeFirst();
    (DEFAIRE.getP_U())->last();
    (DEFAIRE.getP_U())->append(this);
  }
}

void Route::sauve_defaire(int fc)
{
  if (fc==0) 
    (this->supprime)=TRUE;
  if((DEFAIRE.countP_U()) < (DEFAIRE.NbreMaxDefRef()))
    (DEFAIRE.getP_U())->append(this);             // On met la route (qui se retrouve en tete de Pile).
  else {
    (DEFAIRE.getP_U())->removeFirst();
    (DEFAIRE.getP_U())->last();
    (DEFAIRE.getP_U())->append(this);
  }
}

void Base::defaire()
{
  if (!(DEFAIRE.countP_U()))
    {   
      cout<<"Pas de Undo disponible !!!"<<endl;
    } else {
//      cout<<"GOGO"<<endl;
      ((DEFAIRE.getP_U())->last())->defaire(this);
    }
}

void RouteVille::defaire(Base *base)
{
  (DEFAIRE.getP_R())->append(this);
  if (this->supprime)
    { 
      if (this->estVille())    // on remet la ville en appelant les fonctions et mthodes qu'il faut : 
	{ // On cre une nouvelle Ville.
	  Ville *v4=new Ville(((DEFAIRE.getP_U())->getLast())->retx(),((DEFAIRE.getP_U())->getLast())->rety());
	  Ville *v3=new Ville(((DEFAIRE.getP_U())->getLast())->retx(),((DEFAIRE.getP_U())->getLast())->rety());
	  // On lui donne les memes attributs que celles qui a t sauve.
	  v3->modNom(((DEFAIRE.getP_U())->last())->retNom());
	  v3->modPop(((DEFAIRE.getP_U())->last())->retPop());
	  v3->modAlt(((DEFAIRE.getP_U())->last())->retAlt());
	  v3->modReg(((DEFAIRE.getP_U())->last())->retReg());
	  v3->modTyp(((DEFAIRE.getP_U())->last())->retTyp());
	  
	  // On insre la ville dans la Base de Donnes.
//	  base->inserer((Ville*)(DEFAIRE.getP_U())->last());
	  base->inserer(v3);

	  // On remet les villes qui lui taient lies :
	  QList<Route> undo_routes;
	  Ville *v1; Ville *v2;
	  undo_routes=((DEFAIRE.getP_U())->last())->retVoisins();
	  Route *rout;
	  rout=undo_routes.first();
	  while(rout!=NULL)
	    {
	      if ((rout->retextrem1())==NULL)
		{
		  rout->modextrem1(v3);
//		  cout<<"coucou1   "<<(rout->retextrem2())<<endl;
		  for (v1 = base->premVille() ; v1 !=0  ; v2 = v1 , v1 = base->villeSuiv(v2))
		    {
//		      cout<<"coco1   "<<v1<<endl;
		      if (v1 == (rout->retextrem2()))
			{
//			  cout<<"gogo1"<<endl;
			  (rout->retextrem1())->ajoutVoisin(rout);
			  (rout->retextrem2())->ajoutVoisin(rout);
			  base->inserer(rout);
			}
		    }
		} else {
		  rout->modextrem2(v3);
//		  cout<<"coucou2   "<<(rout->retextrem1())<<endl;
		  for (v1 = base->premVille() ; v1 != 0 ; v2 = v1 , v1 = base->villeSuiv(v2))
		    {
		      //		      cout<<"coco2   "<<v1<<endl;
		      if (v1 == (rout->retextrem1()))
			{
			  //			  cout<<"gogo2"<<endl;
			  (rout->retextrem1())->ajoutVoisin(rout);		  
			  (rout->retextrem2())->ajoutVoisin(rout);		  
			  base->inserer(rout);
			}
		    }
		}
	      rout=undo_routes.next();
	    }
	  delete v4;  
	} else {
//	  cout<<"ON REMET UNE ROUTE"<<endl;
	  Ville *v1; Ville *v2; Ville *v3; Ville *v4; Ville *v5; Ville *v6;
	  v3=((DEFAIRE.getP_U())->last())->retextrem1();
	  v4=((DEFAIRE.getP_U())->last())->retextrem2();
	  for (v1 = base->premVille() ; v1 != 0 ; v2 = v1 , v1 = base->villeSuiv(v2))
	    {
	      if (v1 == v3)
		{
		  for (v5 = base->premVille() ; v5 != 0 ; v6 = v5 , v5 = base->villeSuiv(v6))
		    {
		      if (v5 == v4)
			{
			  Route *r3=new Route(v3, v4);
			  r3->modLongueur(((DEFAIRE.getP_U())->last())->retLongueur());
			  r3->modType(((DEFAIRE.getP_U())->last())->retType());
			  r3->modNom(((DEFAIRE.getP_U())->last())->retNom());	  
			  
			  base->inserer(r3); 
			}
		    } 
		}
	    }
	}
      (DEFAIRE.getP_U())->removeLast();	 
    }
}

void Base::refaire()
{
  if (!(DEFAIRE.countP_R()))
    {   
      cout<<"Pas de Redo disponible !!!"<<endl;
    } else {
      ((DEFAIRE.getP_R())->last())->refaire(this);
    }
}

void RouteVille::refaire(Base *base)
{
/*  
  (DEFAIRE.getP_U())->append(this);
  base->supprimer((DEFAIRE.getP_U())->last());
*/
}  



